#
# Copyright (c) 2008 Tilman Sauerbeck (tilman at code-monkey de)
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

# a colormap with 256 entries.
class Palette
	def Palette.from_file(file)
		File.open(file, "rb") do |f|
			Palette.from_buf(f.read)
		end
	end

	def Palette.from_buf(buf)
		Palette.new(buf)
	end

	def initialize(buf)
		# if it's a palette file with a header, ignore that header
		if buf.length == 772
			buf = buf[4..-1]
		end

		@colors = []
		offset = 0

		255.times do |i|
			@colors << buf[offset, 3].unpack("CCC")
			offset += 3
		end
	end

	# returns the color at the given index.
	def color(index)
		@colors[index]
	end
end
